package com.brilliance.isc.common.bop.cfa.cfabop.register.impl;

import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.isc.bo.model.Cfabop;
import com.brilliance.isc.bo.model.CfaeadBizInfo;
import com.brilliance.isc.bo.model.CfaecaBizInfo;
import com.brilliance.isc.common.bop.cfa.cfabop.register.CfabopRegister;
import com.brilliance.isc.vo.remit.CpdBizInfoVo;
import org.springframework.stereotype.Service;

@Service("cpd.cfabopRegister")
public class CpdCfabopRegisterImpl implements CfabopRegister {
    @Override
    public void registerCfabopBizInfo(Cfabop cfabop, String cfatyp) {
        if(MdaUtils.isEmpty(cfatyp)){
            cspsLogger.warn("报送类型为空，组数结束!");
            return;
        }

        CpdBizInfoVo cpdbiz = (CpdBizInfoVo) cfabop.getRec();

        //依据报送类型 进行报送要素提取
        switch (cfatyp)
        {
            case "ECA":
                CfaecaBizInfo cfaecaBizInfo = cfabop.getCfaeca().getCfaecaBizInfo();
                cfaecaBizInfo.setFinownref(cpdbiz.getTrtcreVo().getTrdgrp().getRec().getOwnref());
                cfaecaBizInfo.setStttendat(cpdbiz.getTrtcreVo().getTrdgrp().getRec().getOpndat());
                cfaecaBizInfo.setMatdat(cpdbiz.getTrtcreVo().getTrdgrp().getRec().getMatdat());
                cfaecaBizInfo.setCfarat(cpdbiz.getTrtcreVo().getTrdgrp().getRec().getActrat());
                cfaecaBizInfo.setFincod(cpdbiz.getTrtcreVo().getFinmod().getFincod());
                cfaecaBizInfo.setFinamt(cpdbiz.getTrtcreVo().getFinmod().getCbs().getCbe().getAmt());
                cfaecaBizInfo.setIntamt(cpdbiz.getTrtcreVo().getFinmod().getIntamt());
                cfaecaBizInfo.setTotint(cpdbiz.getTrtcreVo().getFinmod().getCbs().getTotint());
                cfaecaBizInfo.setMaxcur(cpdbiz.getTrtcreVo().getTrdgrp().getCbs().getMax().getCur());
                cfaecaBizInfo.setMaxamt(cpdbiz.getTrtcreVo().getTrdgrp().getCbs().getMax().getAmt());
                break;
            case "EAD":
                CfaeadBizInfo cfaeadBizInfo = cfabop.getCfaead().getCfaeadBizInfo();
                cfaeadBizInfo.setDfdownref(cpdbiz.getDftcreVo().getDfdgrp().getRec().getOwnref());
                cfaeadBizInfo.setMatdat(cpdbiz.getDftcreVo().getDfdgrp().getRec().getMatdat());
                cfaeadBizInfo.setStttendat(cpdbiz.getDftcreVo().getDfdgrp().getRec().getStttendat());
                cfaeadBizInfo.setActrat(cpdbiz.getDftcreVo().getDfdgrp().getRec().getActrat());
                cfaeadBizInfo.setFlttyp(cpdbiz.getDftcreVo().getDfdgrp().getRec().getFlttyp());
                cfaeadBizInfo.setBankcn(cpdbiz.getDftcreVo().getDfdgrp().getRec().getBankcn());
                cfaeadBizInfo.setRescur(cpdbiz.getDftcreVo().getDfdgrp().getRec().getRescur());
                cfaeadBizInfo.setResamt(cpdbiz.getDftcreVo().getDfdgrp().getRec().getResamt());
                cfaeadBizInfo.setMaxcur(cpdbiz.getDftcreVo().getDfdgrp().getCbs().getMax().getCur());
                cfaeadBizInfo.setMaxamt(cpdbiz.getDftcreVo().getDfdgrp().getCbs().getMax().getAmt());
                cfaeadBizInfo.setDff(cpdbiz.getDftcreVo().getDfdgrp().getDff());
                break;
            default:
                break;
        }
    }
}
